<?php
/**
 * @package SEBotsLog
 * @version 0.1.5
 */

/*
Plugin Name: SE Bots Log
Plugin URI: http://4remind.ru/wordpress/plaginy-wordpress/plagin-statistiki-poseshheniy-sayta-robotami-populyarnyh-poiskovyh-sistem.html
Description: SE Bots Log - плагин для сбора статистики посещения сайта роботами поисковых систем.
Version: 0.1.5
Author: 4remind.ru :: Владимир
Author URI: http://4remind.ru
License: GPLv2 or later
Copyright 2012 4remind.ru
*/

/*  
Copyright 2012  4remind.ru  (email: 4remind.ru@gmail.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

$sebotsLogs_version = '0.1.5';
$se_req_date = current_time('mysql');
$sebotsLogs_se_name = '';
$sebotsLogs_se_bot = '';
$day = 86400; // 24*60*60

function sebotslogs_options_page() {

	global $wpdb;
	global $day;
	global $sebotsLogs_version;

	echo '<h2><span style="color:#880000;font-weight:bold;">SE Bots Log</span></h2>';
	echo '<h3>Плагин сбора статистики посещений блога роботами поисковых систем Yandex, Google, Mail.ru</h3>';
	echo '<p>Версия: ' . $sebotsLogs_version . '<br />Автор плагина <a href="http://4remind.ru" target="_blank">4remind.ru</a></p>';
	echo '<b>Текущая дата и время сервера: ' . current_time( 'mysql' ) . '</b><br />';
	echo '<h3>Статистика SE Bots Log</h3>';

	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Yandex"';
	$se_total_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Yandex" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - $day ) . '"';
	$se_today_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Yandex" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 2*$day ) . '" AND `date` <= "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - $day ) . '"';
	$se_yesterday_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Yandex" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 7*$day) . '"';
	$se_lastweek_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Yandex" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 30*$day) . '"';
	$se_lastmonth_count = $wpdb->get_var( $wpdb->prepare( $sql ));

	$sql = 'SELECT `date` FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Yandex" ORDER BY `id` DESC LIMIT 1';
	$se_last_datatime_count = $wpdb->get_var( $wpdb->prepare( $sql ));

	echo '<table cellspacing="0" cellpadding="4" border="1">';
	echo '<tr style="font-weight:bold;" bgcolor="#dddddd"><td align="center">ПС</td><td align="center">Сегодня</td><td align="center">Вчера</td><td align="center">За 7 дней</td><td align="center">За 30 дней</td><td align="center">Всего</td><td align="center">Последнее посещение</td></tr>';
	echo '<tr><td align="center"><b><a href="http://webmaster.yandex.ru/sites/" target="_blank">Yandex</a></b></td><td align="center">' . $se_today_count . '</td><td align="center">' . $se_yesterday_count . '</td><td align="center">' . $se_lastweek_count . '</td><td align="center">' . $se_lastmonth_count . '</td><td align="center">' . $se_total_count . '</td><td align="center">' . $se_last_datatime_count . '</td></tr><br />';

	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Google"';
	$se_total_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Google" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - $day ) . '"';
	$se_today_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Google" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 2*$day ) . '" AND `date` <= "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - $day ) . '"';
	$se_yesterday_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Google" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 7*$day ) . '"';
	$se_lastweek_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Google" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 30*$day ) . '"';
	$se_lastmonth_count = $wpdb->get_var( $wpdb->prepare( $sql ));

	$sql = 'SELECT `date` FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Google" ORDER BY `id` DESC LIMIT 1';
	$se_last_datatime_count = $wpdb->get_var( $wpdb->prepare( $sql ));

	echo '<tr><td align="center"><b><a href="https://www.google.com/webmasters/tools/" target="_blank">Google</a></b></td><td align="center">' . $se_today_count . '</td><td align="center">' . $se_yesterday_count . '</td><td align="center">' . $se_lastweek_count . '</td><td align="center">' . $se_lastmonth_count . '</td><td align="center">' . $se_total_count . '</td><td align="center">' . $se_last_datatime_count . '</td></tr><br />';

	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Mail.ru"';
	$se_total_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Mail.ru" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - $day ) . '"';
	$se_today_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Mail.ru" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 2*$day ) . '" AND `date` <= "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - $day ) . '"';
	$se_yesterday_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Mail.ru" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 7*$day ) . '"';
	$se_lastweek_count = $wpdb->get_var( $wpdb->prepare( $sql ));
	$sql = 'SELECT COUNT(*) FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Mail.ru" AND `date` > "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 30*$day ) . '"';
	$se_lastmonth_count = $wpdb->get_var( $wpdb->prepare( $sql ));

	$sql = 'SELECT `date` FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `name`="Mail.ru" ORDER BY `id` DESC LIMIT 1';
	$se_last_datatime_count = $wpdb->get_var( $wpdb->prepare( $sql ));

	echo '<tr><td align="center"><b><a href="http://webmaster.mail.ru/" target="_blank">Mail.ru</a></b></td><td align="center">' . $se_today_count . '</td><td align="center">' . $se_yesterday_count . '</td><td align="center">' . $se_lastweek_count . '</td><td align="center">' . $se_lastmonth_count . '</td><td align="center">' . $se_total_count . '</td><td align="center">' . $se_last_datatime_count . '</td></tr>';
	echo '</table><br />';

echo <<<HELP1
	<div>
		<div>
			<input type="button" value="Справка" style="font-weight:bold;cursor:pointer;background-color: inherit; border: 1px solid #000;" onclick="if (this.parentNode.parentNode.getElementsByTagName('div')[1].getElementsByTagName('div')[0].style.display != '') { this.parentNode.parentNode.getElementsByTagName('div')[1].getElementsByTagName('div')[0].style.display = ''; this.innerText = ''; this.value = 'Скрыть справку'; } else { this.parentNode.parentNode.getElementsByTagName('div')[1].getElementsByTagName('div')[0].style.display = 'none'; this.innerText = ''; this.value = 'Справка'; }"/>
		</div>
		<div>
			<div style="display: none; padding: 10px; margin-right: 20px; border: 1px #aaa solid;">
				<span>
					<ol>
						<li>При активации плагина в базе данных создается дополнительная таблица с именем «вашпрефикс_sebotslogs_se», и используется она только для работы плагина SE Bots Log.<br /></li>
						<li>При деактивации плагина созданная таблица не удаляется из базы данных, и все данные в ней сохранятся.<br /></li>
						<li>Таблица будет удалена из базы данных, если Вы удалите плагин соответствующей командой из консоли WordPress.<br /></li>
						<li>НЕ рекомендуется удалять плагин вручную, т.е. методом ручного удаления каталога плагина и его файлов, так как в этом случае в базе данных останется таблица «вашпрефикс_sebotslogs_se».<br /></li>
						<li>Во избежание переполнения Базы Данных записи в таблице «вашпрефикс_sebotslogs_se» сохраняются максимум за последние 90 дней (3 месяца), т.е. все записи, срок давности у которых больше 90 дней, удаляются автоматически.</li>
					</ol>
				</span>
			</div>
		</div>
	</div>
HELP1;
 /* !!! Do NOT place any tab or space before 'HELP1;' !!! */

	$sql = 'DELETE FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `date` < "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 90*$day ) . '"';
	$wpdb->query( $sql );

	unset( $sql, $se_today_count, $se_yesterday_count, $se_lastweek_count, $se_lastmonth_count, $se_total_count );
}

function sebotslogs_add_se_db() {

	global $se_req_date;
	global $sebotslogs_se_name;
	global $sebotslogs_se_bot;
	global $wpdb;
	global $day;

	$table_se = $wpdb->prefix.sebotslogs_se;

	$se_req_date = current_time('mysql');
	$wpdb->insert(
		$table_se,
		array( 'name' => $sebotslogs_se_name, 'bot' => $sebotslogs_se_bot, 'date' => $se_req_date ),
		array( '%s', '%s', '%s' )
	);

	$randomval = mt_rand( 0, 10 );
	if( $randomval > 9 ) {
		$sql_a = 'DELETE FROM `' . $wpdb->prefix.sebotslogs_se . '` WHERE `date` < "' . date( 'Y-m-d 23:59:59', current_time( 'timestamp' ) - 90*$day ) . '"';
		$wpdb->query( $sql_a );
		unset( $sql_a );
	}

	unset( $randomval );
}

function sebotslogs_check_se_robots() {

	global $se_req_date;
	global $sebotslogs_se_name;
	global $sebotslogs_se_bot;

	if( isset( $_SERVER['HTTP_USER_AGENT'] ) && isset( $_SERVER['REQUEST_URI'] )) {
		$is_bot = FALSE;

		if( stripos( $_SERVER['HTTP_USER_AGENT'], " yandex" ) && stripos( $_SERVER['HTTP_USER_AGENT'], " +http://yandex.com/bots" )) {
			$is_bot = TRUE;
			$sebotslogs_se_name = "Yandex";
		} elseif( stripos( $_SERVER['HTTP_USER_AGENT'], " googlebot" )) {
			$is_bot = TRUE;
			$sebotslogs_se_name = "Google";
		} elseif( stripos( $_SERVER['HTTP_USER_AGENT'], " mail.ru" )) {
			$is_bot = TRUE;
			$sebotslogs_se_name = "Mail.ru";
		}

		if( $is_bot == TRUE ) {
			sebotslogs_add_se_db();
		}

		unset( $is_bot );
	}
}

function sebotslogs_run() {
	sebotslogs_check_se_robots();
}

function sebotslogs_activation() {

	global $wpdb;

	$table_se = $wpdb->prefix.sebotslogs_se;

	$sql = "CREATE TABLE IF NOT EXISTS `".$table_se."` (
			`id` BIGINT(14) UNSIGNED NOT NULL AUTO_INCREMENT,
			`name` varchar(64) NOT NULL,
			`bot` varchar(64) NOT NULL,
			`date` datetime NOT NULL,
			PRIMARY KEY (`id`)
		) DEFAULT CHARSET=utf8;";

	$wpdb->query( $sql );
}

function sebotslogs_deactivation() {
}

function sebotslogs_uninstall() {

	global $wpdb;

	$table_se = $wpdb->prefix.sebotslogs_se;

	$sql = "DROP TABLE `" . $table_se . "`;";

	$wpdb->query( $sql );
}

register_activation_hook( __FILE__, 'sebotslogs_activation' );
register_deactivation_hook( __FILE__, 'sebotslogs_deactivation' );
register_uninstall_hook( __FILE__, 'sebotslogs_uninstall' );

function sebotslogs_add_dashboard_menu() {
	add_dashboard_page('Статистика SE Bots Log', 'SE Bots Log', 'administrator', 'sebotslogs-dashboard', 'sebotslogs_options_page');
}

function sebotslogs_add_admin_pages() {
	add_options_page( 'Статистика SE Bots Log', 'SE Bots Log', 8, 'sebotslogs', 'sebotslogs_options_page' );
}

add_action( 'admin_menu', 'sebotslogs_add_dashboard_menu' );
add_action( 'admin_menu', 'sebotslogs_add_admin_pages' );
add_action( 'init', 'sebotslogs_run' );

?>